<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('express.courierCompanyNumber')" prop="code">
        <el-input v-model="formData.code" :placeholder="t('express.pleaseEnterTheCourierCompanyNumber')" />
      </el-form-item>
      <el-form-item :label="t('express.fullNameOfCourierCompany')" prop="name">
        <el-input v-model="formData.name" :placeholder="t('express.pleaseEnterTheFullNameOfCourierCompany')" />
      </el-form-item>
      <el-form-item :label="t('express.sort')" prop="sort">
        <el-input v-model="formData.sort" :placeholder="t('express.pleaseEnterTheSort')" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{t('common.confirm')}}</el-button>
      <el-button @click="dialogVisible = false">{{t('common.cancel')}}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as ExpressApi from '@/api/express'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  code: undefined,
  name: undefined,
  sort: undefined
})
const formRules = reactive({
  code: [{ required: true, message: t('express.theAbbreviationCourierCompanyEmpty'), trigger: 'blur' }],
  name: [{ required: true, message: t('express.fullNameCourierCompanyEmpty'), trigger: 'blur' }],
  sort: [{ required: true, message: t('express.sortCannotEmpty'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ExpressApi.getExpress(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ExpressApi.ExpressVO
    if (formType.value === 'create') {
      await ExpressApi.createExpress(data)
      message.success(t('common.createSuccess'))
    } else {
      await ExpressApi.updateExpress(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    code: undefined,
    name: undefined,
    sort: undefined
  }
  formRef.value?.resetFields()
}
</script>
